import java.util.ArrayList;

//Here are a few past FRQs similar to this FRQ
//2010 CookieOrder
//2012 ClimbingClub
//2018 WordPair

public class OnlinePurchaseManager
{
   //purchases stores Gizmos
   private ArrayList<Gizmo> purchases;
   
   //point purchases at a new ArrayList   
   public OnlinePurchaseManager()
   {
   	purchases = new ArrayList<Gizmo>();
   }
   
   
   //NOT part of the sample question
   //needed in order to type up and
   //test student code
   public void add( String m, boolean e, double c )
   {
   	purchases.add( new Gizmo( m, e, c) );
   }
   
   
   //Part A
   //count the number of Gizmos made by maker
   //that are also electronic
   //must call getMaker and isElectronic
   //return the count or 0 if no matches
   public int countElectronicsByMaker(String maker)
   {   
   	int count = 0;
   	for( Gizmo g : purchases )
   	{
   		if( g.getMaker().equals( maker ) && g.isElectronic()==true )
   			count = count + 1;  //or count++
   	}
   	return count;   	
   }
   

   //Part B
   //loop thought the list and check for matching adjacent pairs
   //return true of any adjacent [ side by side ] pairs are the same
   //to be the same the pairs must have the same maker and
   //be either electronic or non-electronic
   //you really really should use the equals method from Gizmo
   public boolean hasAdjacentEqualPair()
   {  
   	for( int i = 0; i < purchases.size()-1; i++ )
   	{
   		Gizmo curr = purchases.get( i );
   		Gizmo nxt = purchases.get( i + 1 );
   		if( curr.equals( nxt ) )
   			return true;
   	}
   	return false;   	
   }
   
   
   //PART C
   public Gizmo getCheapestGizmoByMaker( String mkr )
   {
   	//several different valid ways to do this
   	double low = Integer.MAX_VALUE;
   	int spot = 0;
   	for( int i = 0; i < purchases.size(); i++ )
   	{
   		Gizmo gz = purchases.get(i);
   		if( gz.getCost() < low && mkr.equals( gz.getMaker() ))
   		{
   			low = gz.getCost();
   			spot = i;
   		}
   	}
   	return purchases.get( spot );   	
   }
   
   
   //NOT part of the sample question
   //needed in order to type up and
   //test student code
   public String toString()
   {
   	return "" + purchases;
   }
}


//Part C
/*
OPEN-ENDED SECTION

A programmer would like to add a method getCheapestGizmoByMaker, 
which returns the least expensive Gizmo purchased by an individual 
from a given maker.

Write a description of how you would change the Gizmo and OnlinePurchaseManager 
classes in order to support this modification. 
 
Make sure to include the following in your response. 

	Write the method header for the getCheapestGizmoByMaker method. 
	DO write code for this part.

	Identify any new or modified variables, constants, constructors, 
   or methods aside from the getCheapestGizmoByMaker method. 
   DO NOT write code for this part.
   
	Describe, for each new or revised variable, constant, constructor, 
   or method, how it would change or be implemented, including visibility and type. 
   You do not need to describe the getCheapestGizmoByMaker method.
   DO NOT write code for this part.
   

////////////////////////////////////////////////////////////////////
//DISCLAIMER  DISCLAIMER  DISCLAIMER  
//DISCLAIMER  DISCLAIMER  DISCLAIMER  
///////////////////////////////////////////////////////////////////
No answers or suggested answers have been posted for the OPEN-ENDED SECTIONS.

Here is my take on part C.

The method header should be public Gizmo getCheapestGizmoByMaker( String mkr ).
The Gizmo class will need a new instance varible to store the cost for each Gizmo
which suggests the Gizmo class will also need a constructor to recieve a cost value
as well as a public method that will return the cost of a Gizmo.
The new private double cost instance variable would store the cost of each Gizmo
allowing the new getCheapestGizmoByMaker method to determine the cost of each Gizmo.




*/

